searchData={"items":[{"type":"module","title":"Mix.PowAssent","doc":"Utilities module for mix tasks.","ref":"Mix.PowAssent.html"},{"type":"task","title":"mix pow_assent.ecto.gen.migration","doc":"Generates a user identity migrations file.\n\n    mix pow_assent.ecto.gen.migration -r MyApp.Repo\n\n    mix pow_assent.ecto.gen.migration -r MyApp.Repo Accounts.Identity identities\n\nThis generator will add a migration file in `priv/repo/migrations` for the\n`user_identities` table","ref":"Mix.Tasks.PowAssent.Ecto.Gen.Migration.html"},{"type":"task","title":"Arguments - mix pow_assent.ecto.gen.migration","doc":"* `-r`, `--repo` - the repo module\n  * `--binary-id` - use binary id for primary key\n  * `--users-table` - what users table to reference, defaults to \"users\"","ref":"Mix.Tasks.PowAssent.Ecto.Gen.Migration.html#module-arguments"},{"type":"task","title":"mix pow_assent.ecto.gen.schema","doc":"Generates a user identity schema.\n\n    mix pow_assent.ecto.gen.schema -r MyApp.Repo\n\n    mix pow_assent.ecto.gen.schema -r MyApp.Repo Accounts.Identity identities\n\nThis generator will add a schema module file in\n`lib/my_app/user_identities/user_identity.ex`.","ref":"Mix.Tasks.PowAssent.Ecto.Gen.Schema.html"},{"type":"task","title":"Arguments - mix pow_assent.ecto.gen.schema","doc":"* `--binary-id` - use binary id for primary key and references\n  * `--context-app` - context app to use for path and module names","ref":"Mix.Tasks.PowAssent.Ecto.Gen.Schema.html#module-arguments"},{"type":"task","title":"mix pow_assent.ecto.install","doc":"Generates user identity schema and migration file.\n\n    mix pow_assent.ecto.install -r MyApp.Repo\n\n    mix pow_assent.ecto.install -r MyApp.Repo Accounts.Identity identities\n\nSee `Mix.Tasks.PowAssent.Ecto.Gen.Schema` and\n`Mix.Tasks.PowAssent.Ecto.Gen.Migration` for more.","ref":"Mix.Tasks.PowAssent.Ecto.Install.html"},{"type":"task","title":"Arguments - mix pow_assent.ecto.install","doc":"* `--no-migrations` - don't generate migration files\n  * `--no-schema` - don't generate schema file","ref":"Mix.Tasks.PowAssent.Ecto.Install.html#module-arguments"},{"type":"task","title":"mix pow_assent.install","doc":"Will generate PowAssent migration file.\n\n    mix pow_assent.install -r MyApp.Repo\n\n    mix pow_assent.install -r MyApp.Repo Accounts.Identity identities\n\nSee `Mix.Tasks.PowAssent.Ecto.Install` for more.","ref":"Mix.Tasks.PowAssent.Install.html"},{"type":"task","title":"mix pow_assent.phoenix.gen.templates","doc":"Generates PowAssent templates for Phoenix.\n\n    mix pow_assent.phoenix.gen.templates\n\n    mix pow_assent.phoenix.gen.templates --context-app my_app","ref":"Mix.Tasks.PowAssent.Phoenix.Gen.Templates.html"},{"type":"task","title":"Arguments - mix pow_assent.phoenix.gen.templates","doc":"* `--context-app` app to use for path and module names","ref":"Mix.Tasks.PowAssent.Phoenix.Gen.Templates.html#module-arguments"},{"type":"task","title":"mix pow_assent.phoenix.install","doc":"Prints instructions fo setting up PowAssent with Phoenix.\n\n    mix pow_assent.phoenix.install -r MyApp.Repo\n\n    mix pow_assent.phoenix.install -r MyApp.Repo --context-app :my_app\n\nTemplates are only generated when `--templates` argument is provided.\n\nSee `Mix.Tasks.PowAssent.Phoenix.Gen.Templates` and\n`Mix.Tasks.PowAssent.Extension.Phoenix.Gen.Templates` for more.","ref":"Mix.Tasks.PowAssent.Phoenix.Install.html"},{"type":"task","title":"Arguments - mix pow_assent.phoenix.install","doc":"* `--context-app` - app to use for path and module names\n  * `--templates` - generate templates\n  * `--extension` - extensions to generate templates for","ref":"Mix.Tasks.PowAssent.Phoenix.Install.html#module-arguments"},{"type":"module","title":"PowAssent.Config","doc":"Methods to parse and modify configurations.","ref":"PowAssent.Config.html"},{"type":"function","title":"PowAssent.Config.get/3","doc":"Gets the key value from the configuration.\n\nIf not found, it'll fall back to environment config, and lastly to the\ndefault value which is `nil` if not specified.","ref":"PowAssent.Config.html#get/3"},{"type":"function","title":"PowAssent.Config.get_provider_config/2","doc":"Gets the provider configuration from the provided configuration.","ref":"PowAssent.Config.html#get_provider_config/2"},{"type":"function","title":"PowAssent.Config.get_providers/1","doc":"Gets the providers for the configuration.","ref":"PowAssent.Config.html#get_providers/1"},{"type":"function","title":"PowAssent.Config.merge_provider_config/3","doc":"Merge new config for provider.\n\nThe new config values are deep merged with the existing provider config. Any\nconflicting keys from the default config for the strategy will be fetched and\nthe provider config deep merged unto it.","ref":"PowAssent.Config.html#merge_provider_config/3"},{"type":"function","title":"PowAssent.Config.put/3","doc":"Puts a new key value to the configuration.","ref":"PowAssent.Config.html#put/3"},{"type":"function","title":"PowAssent.Config.raise_error/1","doc":"Raise a ConfigError exception.","ref":"PowAssent.Config.html#raise_error/1"},{"type":"type","title":"PowAssent.Config.t/0","doc":"","ref":"PowAssent.Config.html#t:t/0"},{"type":"module","title":"PowAssent.Operations","doc":"Operation methods that glues operation calls to context module.\n\nA custom context module can be used instead of the default\n`PowAssent.Ecto.UserIdentities.Context` if a `:user_identities_context` key\nis passed in the PowAssent configuration.","ref":"PowAssent.Operations.html"},{"type":"function","title":"PowAssent.Operations.all/2","doc":"Lists all user identity associations for user.\n\nThis calls `Pow.Ecto.UserIdentities.Context.all/2` or\n`all/1` on a custom context module.","ref":"PowAssent.Operations.html#all/2"},{"type":"function","title":"PowAssent.Operations.create_user/4","doc":"Creates user with user identity with the provided user params.\n\nThis calls `Pow.Ecto.UserIdentities.Context.create_user/4` or\n`create_user/3` on a custom context module.","ref":"PowAssent.Operations.html#create_user/4"},{"type":"function","title":"PowAssent.Operations.delete/3","doc":"Deletes the user identity for user and strategy provider name.\n\nThis calls `Pow.Ecto.UserIdentities.Context.delete/3` or\n`delete/2` on a custom context module.","ref":"PowAssent.Operations.html#delete/3"},{"type":"function","title":"PowAssent.Operations.get_user_by_provider_uid/3","doc":"Retrieve a user with the strategy provider name and uid.\n\nThis calls `Pow.Ecto.UserIdentities.Context.get_user_by_provider_uid/3` or\n`get_user_by_provider_uid/2` on a custom context module.","ref":"PowAssent.Operations.html#get_user_by_provider_uid/3"},{"type":"function","title":"PowAssent.Operations.upsert/3","doc":"Upserts user identity for the user, and strategy provider name and uid.\n\nThis calls `Pow.Ecto.UserIdentities.Context.upsert/3` or\n`upsert/2` on a custom context module.","ref":"PowAssent.Operations.html#upsert/3"},{"type":"function","title":"PowAssent.Operations.user_identity_changeset/4","doc":"Build a changeset from a blank user struct.\n\nIt'll use the schema module fetched from the config through\n`Pow.Config.user!/1` and call `user_identity_changeset/4` on it.","ref":"PowAssent.Operations.html#user_identity_changeset/4"},{"type":"module","title":"PowAssent.Plug","doc":"Plug helper methods.\n\nIf you wish to configure PowAssent through the Pow plug interface rather than\nenvironment config, please add PowAssent config with `:pow_assent` config:\n\n    plug Pow.Plug.Session,\n      repo: MyApp.Repo,\n      user: MyApp.User,\n      pow_assent: [\n        http_adapter: PowAssent.HTTPAdapter.Mint,\n        json_library: Poison,\n        user_identities_context: MyApp.UserIdentities\n      ]","ref":"PowAssent.Plug.html"},{"type":"function","title":"PowAssent.Plug.authenticate/2","doc":"Authenticates a user with provider and provider user params.\n\nIf successful, a new session will be created. After session has been created\nthe callbacks stored with `put_create_session_callback/2` will run.","ref":"PowAssent.Plug.html#authenticate/2"},{"type":"function","title":"PowAssent.Plug.authorize_url/3","doc":"Calls the authorize_url method for the provider strategy.\n\nA generated authorization URL will be returned. If `:session_params` is\nreturned from the provider, it'll be added to the connection as private key\n`:pow_assent_session_params`.\n\nIf `:nonce` is set to `true` in the PowAssent provider configuration, a\nrandomly generated nonce will be added to the provider configuration.","ref":"PowAssent.Plug.html#authorize_url/3"},{"type":"function","title":"PowAssent.Plug.available_providers/1","doc":"Lists available providers for connection.","ref":"PowAssent.Plug.html#available_providers/1"},{"type":"function","title":"PowAssent.Plug.callback/4","doc":"Calls the callback method for the provider strategy.\n\nReturns the user identity params and user params fetched from the provider.\n\n`:session_params` will be added to the provider config if\n`:pow_assent_session_params` is present as a private key in the connection.","ref":"PowAssent.Plug.html#callback/4"},{"type":"function","title":"PowAssent.Plug.callback_upsert/4","doc":"Calls the callback method for the provider strategy and will authenticate,\nupsert user identity, or create user.\n\nSee `callback/4`, `authenticate/2`, `upsert_identity/2`, and `create_user/4`\nfor more.\n\nTo track the state of the flow the following keys may be populated in\n`conn.private`:\n\n  - `:pow_assent_callback_state` - The state of the flow, that is either\n    `{:ok, step}` or `{:error, step}`.\n  - `:pow_assent_callback_params` - The params returned by the strategy\n    callback phase.\n  - `:pow_assent_callback_error` - The resulting error of any step.\n\nThe value of `:pow_assent_callback_state` may be one of the following:\n\n- `{:error, :strategy}` - An error ocurred during strategy callback\n    phase. `:pow_assent_callback_error` will be populated with the error.\n- `{:ok, :upsert_user_identity}` - User identity was created or updated.\n- `{:error, :upsert_user_identity}` - User identity could not be created\n  or updated. `:pow_assent_callback_error` will be populated with the\n  changeset.\n- `{:ok, :create_user}` - User was created.\n- `{:error, :create_user}` - User could not be created.\n  `:pow_assent_callback_error` will be populated with the changeset.\n\nIf `:pow_assent_registration` in `conn.private` is set to `false` then\n`create_user/4` will not be called and the `:pow_assent_callback_state` set\nto `{:error, :create_user}` with `nil` value for\n`:pow_assent_callback_error`.","ref":"PowAssent.Plug.html#callback_upsert/4"},{"type":"function","title":"PowAssent.Plug.change_user/4","doc":"Creates a changeset.","ref":"PowAssent.Plug.html#change_user/4"},{"type":"function","title":"PowAssent.Plug.create_user/4","doc":"Create a user with the provider and provider user params.\n\nIf successful, a new session will be created. After session has been created\nthe callbacks stored with `put_create_session_callback/2` will run.","ref":"PowAssent.Plug.html#create_user/4"},{"type":"function","title":"PowAssent.Plug.delete_identity/2","doc":"Deletes the associated user identity for the current user and provider.","ref":"PowAssent.Plug.html#delete_identity/2"},{"type":"function","title":"PowAssent.Plug.delete_session/2","doc":"Deletes key from session.","ref":"PowAssent.Plug.html#delete_session/2"},{"type":"function","title":"PowAssent.Plug.fetch_config/1","doc":"Fetch PowAssent configuration from the Pow configration.\n\nCalls `Pow.Plug.fetch_config/1` and fetches the `pow_assent` key value.","ref":"PowAssent.Plug.html#fetch_config/1"},{"type":"function","title":"PowAssent.Plug.init_session/1","doc":"Initializes session.\n\nSession data will be fetched and deleted from the PowAssent session store if\nan auth session cookie was found. The session data is set for the\n`:pow_assent_session_info` key in in `conn.private`.\n\nA `:before_send` callback will be set to store session data. If\n`:pow_assent_session` key in `conn.private` has been populated, a random UUID\nis generated and used as the key for the stored session data. The UUID is\nthen stored as the value for the auth session cookie.","ref":"PowAssent.Plug.html#init_session/1"},{"type":"function","title":"Configuration options - PowAssent.Plug.init_session/1","doc":"The configuration is fetched with `fetch_config/1`.\n\n  * `:session_store` - the session store. This value\n    defaults to\n    `{PowAssent.Store.SessionCache, backend: Pow.Store.Backend.EtsCache}`.\n    The `Pow.Store.Backend.EtsCache` backend store can be changed with the\n    `:cache_store_backend` option.\n\n  * `:auth_session_cookie_key` - The cookie key name to use. Defaults to\n    \"auth_session\". If `:otp_app` is used it'll automatically prepend the key\n    with the `:otp_app` value.\n\n  * `:auth_session_cookie_opts` - keyword list of cookie options, see\n    `Plug.Conn.put_resp_cookie/4` for options. The default options are\n    `[path: \"/\"]`.","ref":"PowAssent.Plug.html#init_session/1-configuration-options"},{"type":"function","title":"PowAssent.Plug.merge_provider_config/3","doc":"Merges existing provider config with new config in the conn.\n\nThe existing config is fetched with `fetch_config/1`, and the new config deep\nmerged unto it with `PowAssent.Config.merge_provider_config/3`. The updated\nconfig will be set as `:pow_assent` config value for the Pow config for the\nconn with `Pow.Plug.put_config/2`.","ref":"PowAssent.Plug.html#merge_provider_config/3"},{"type":"function","title":"PowAssent.Plug.providers_for_current_user/1","doc":"Lists associated providers for the user.","ref":"PowAssent.Plug.html#providers_for_current_user/1"},{"type":"function","title":"PowAssent.Plug.put_create_session_callback/2","doc":"Store a callback method to run after session is created.","ref":"PowAssent.Plug.html#put_create_session_callback/2"},{"type":"function","title":"PowAssent.Plug.put_session/3","doc":"Inserts value for key in session.","ref":"PowAssent.Plug.html#put_session/3"},{"type":"function","title":"PowAssent.Plug.upsert_identity/2","doc":"Will upsert identity for the current user.\n\nIf successful, a new session will be created. After session has been created\nthe callbacks stored with `put_create_session_callback/2` will run.","ref":"PowAssent.Plug.html#upsert_identity/2"},{"type":"module","title":"PowAssent.Plug.Reauthorization","doc":"This plug can reauthorize a user who signed in through a provider.\n\nThe plug is dependent on a `:handler` that has the following methods:\n\n * `reauthorize?/2` - verifies the request for reauthorization condition. If\n  the condition exists for the request (usually the sign in path), the\n  reauthorization cookie will be fetched and deleted, the `reauthorize/2`\n  callback will be called, and the connection halted.\n\n* `clear_reauthorization?/2` - verifies the request for clear reauthorization\n  condition. If the condition exists (usually the session delete path) then\n  the cookie is deleted.\n\n* `reauthorize/3` - the callback to handle the request when a reauthorization\n  condition exists. Usually this would redirect the user.\n\nSee `PowAssent.Phoenix.ReauthorizationPlugHandler` for a Phoenix example.","ref":"PowAssent.Plug.Reauthorization.html"},{"type":"module","title":"Example - PowAssent.Plug.Reauthorization","doc":"plug PowAssent.Plug.Reauthorization,\n      handler: MyApp.ReauthorizationHandler","ref":"PowAssent.Plug.Reauthorization.html#module-example"},{"type":"module","title":"Configuration options - PowAssent.Plug.Reauthorization","doc":"* `:handler` - the handler module. Should either be a module or a tuple\n    `{module, options}`.\n\n  * `:reauthorization_cookie_key` - reauthorization key name. This defaults\n    to \"authorization_provider\". If `:otp_app` is used it'll automatically\n    prepend the key with the `:otp_app` value.\n\n  * `:reauthorization_cookie_opts` - keyword list of cookie options, see\n    `Plug.Conn.put_resp_cookie/4` for options. The default options are\n    `[max_age: max_age, path: \"/\"]` where `:max_age` is 30 days.","ref":"PowAssent.Plug.Reauthorization.html#module-configuration-options"},{"type":"module","title":"PowAssent.Store.SessionCache","doc":"Default module for session storage.","ref":"PowAssent.Store.SessionCache.html"},{"type":"function","title":"PowAssent.Store.SessionCache.backend_config/1","doc":"","ref":"PowAssent.Store.SessionCache.html#backend_config/1"},{"type":"behaviour","title":"PowAssent.Ecto.Schema","doc":"Handles the Ecto schema for user.\n\n`user_id_attrs` is provided by the user in a registration step.","ref":"PowAssent.Ecto.Schema.html"},{"type":"behaviour","title":"Usage - PowAssent.Ecto.Schema","doc":"Configure `lib/my_project/users/user.ex` the following way:\n\n    defmodule MyApp.Users.User do\n      use Ecto.Schema\n      use Pow.Ecto.Schema\n      use PowAssent.Ecto.Schema\n\n      schema \"users\" do\n        field :custom_field, :string\n\n        pow_user_fields()\n\n        timestamps()\n      end\n\n      def changeset(user_or_changeset, attrs) do\n        user_or_changeset\n        |> Ecto.Changeset.cast(attrs, [:custom_field])\n        |> pow_changeset(attrs)\n      end\n\n      def user_identity_changeset(user_or_changeset, user_identity, attrs, user_id_attrs) do\n        user_or_changeset\n        |> Ecto.Changeset.cast(attrs, [:custom_field])\n        |> pow_assent_user_identity_changeset(user_identity, attrs, user_id_attrs)\n      end\n    end","ref":"PowAssent.Ecto.Schema.html#module-usage"},{"type":"function","title":"PowAssent.Ecto.Schema.changeset/5","doc":"Changeset for creating or updating users with a user identity.\n\nOnly `Pow.Ecto.Schema.Changeset.user_id_field_changeset/3` is used for\nvalidation as password is not required.","ref":"PowAssent.Ecto.Schema.html#changeset/5"},{"type":"callback","title":"PowAssent.Ecto.Schema.user_identity_changeset/4","doc":"","ref":"PowAssent.Ecto.Schema.html#c:user_identity_changeset/4"},{"type":"behaviour","title":"PowAssent.Ecto.UserIdentities.Context","doc":"Handles pow assent user identity context for user identities.","ref":"PowAssent.Ecto.UserIdentities.Context.html"},{"type":"behaviour","title":"Usage - PowAssent.Ecto.UserIdentities.Context","doc":"This module will be used by PowAssent by default. If you wish to have control\nover context methods, you can do configure\n`lib/my_project/user_identities/user_identities.ex` the following way:\n\n    defmodule MyApp.UserIdentities do\n      use PowAssent.Ecto.UserIdentities.Context,\n        repo: MyApp.Repo,\n        user: MyApp.Users.User\n\n      def all(user) do\n        pow_assent_all(user)\n      end\n    end\n\nRemember to update the PowAssent configuration with\n`user_identities_context: MyApp.UserIdentities`.\n\nThe following Pow methods can be accessed:\n\n  * `pow_assent_get_user_by_provider_uid/3`\n  * `pow_assent_upsert/2`\n  * `pow_assent_create_user/3`\n  * `pow_assent_delete/2`\n  * `pow_assent_all/1`","ref":"PowAssent.Ecto.UserIdentities.Context.html#module-usage"},{"type":"behaviour","title":"Configuration options - PowAssent.Ecto.UserIdentities.Context","doc":"* `:repo` - the ecto repo module (required)\n  * `:user` - the user schema module (required)","ref":"PowAssent.Ecto.UserIdentities.Context.html#module-configuration-options"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Context.all/1","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#c:all/1"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.all/2","doc":"Fetches all user identities for user.\n\nRepo module will be fetched from config.","ref":"PowAssent.Ecto.UserIdentities.Context.html#all/2"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Context.create/2","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#c:create/2"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Context.create_user/3","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#c:create_user/3"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.create_user/4","doc":"Creates a user with user identity.\n\nUser schema module and repo module will be fetched from config.","ref":"PowAssent.Ecto.UserIdentities.Context.html#create_user/4"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Context.delete/2","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#c:delete/2"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.delete/3","doc":"Deletes a user identity for the provider and user.\n\nRepo module will be fetched from config.","ref":"PowAssent.Ecto.UserIdentities.Context.html#delete/3"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Context.get_user_by_provider_uid/2","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#c:get_user_by_provider_uid/2"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.get_user_by_provider_uid/3","doc":"Finds a user based on the provider and uid.\n\nUser schema module and repo module will be fetched from the config.","ref":"PowAssent.Ecto.UserIdentities.Context.html#get_user_by_provider_uid/3"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.repo!/1","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#repo!/1"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Context.upsert/2","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#c:upsert/2"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.upsert/3","doc":"Upserts a user identity.\n\nIf a matching user identity already exists for the user, the identity will be updated,\notherwise a new identity is inserted.\n\nRepo module will be fetched from config.","ref":"PowAssent.Ecto.UserIdentities.Context.html#upsert/3"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Context.user!/1","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#user!/1"},{"type":"type","title":"PowAssent.Ecto.UserIdentities.Context.changeset/0","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#t:changeset/0"},{"type":"type","title":"PowAssent.Ecto.UserIdentities.Context.user/0","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#t:user/0"},{"type":"type","title":"PowAssent.Ecto.UserIdentities.Context.user_id_params/0","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#t:user_id_params/0"},{"type":"type","title":"PowAssent.Ecto.UserIdentities.Context.user_identity/0","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#t:user_identity/0"},{"type":"type","title":"PowAssent.Ecto.UserIdentities.Context.user_identity_params/0","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#t:user_identity_params/0"},{"type":"type","title":"PowAssent.Ecto.UserIdentities.Context.user_params/0","doc":"","ref":"PowAssent.Ecto.UserIdentities.Context.html#t:user_params/0"},{"type":"behaviour","title":"PowAssent.Ecto.UserIdentities.Schema","doc":"Handles the Ecto schema for user identity.\n\nA default `changeset/2` method is created, but can be overridden with a\ncustom `changeset/2` method.","ref":"PowAssent.Ecto.UserIdentities.Schema.html"},{"type":"behaviour","title":"Usage - PowAssent.Ecto.UserIdentities.Schema","doc":"Configure `lib/my_project/user_identities/user_identity.ex` the following way:\n\n    defmodule MyApp.UserIdentities.UserIdentity do\n      use Ecto.Schema\n      use PowAssent.Ecto.UserIdentities.Schema,\n        user: MyApp.Users.User\n\n      schema \"user_identities\" do\n        pow_assent_user_identity_fields()\n\n        timestamps()\n      end\n\n      def changeset(user_identity_or_changeset, attrs) do\n        pow_assent_changeset(user_identity_or_changeset, attrs)\n      end\n    end","ref":"PowAssent.Ecto.UserIdentities.Schema.html#module-usage"},{"type":"behaviour","title":"Configuration options - PowAssent.Ecto.UserIdentities.Schema","doc":"* `:user` - the user schema module to use in the `belongs_to` association.","ref":"PowAssent.Ecto.UserIdentities.Schema.html#module-configuration-options"},{"type":"callback","title":"PowAssent.Ecto.UserIdentities.Schema.changeset/2","doc":"","ref":"PowAssent.Ecto.UserIdentities.Schema.html#c:changeset/2"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.changeset/3","doc":"Validates a user identity.","ref":"PowAssent.Ecto.UserIdentities.Schema.html#changeset/3"},{"type":"macro","title":"PowAssent.Ecto.UserIdentities.Schema.pow_assent_user_identity_fields/0","doc":"Macro for adding user identity schema fields.","ref":"PowAssent.Ecto.UserIdentities.Schema.html#pow_assent_user_identity_fields/0"},{"type":"module","title":"PowAssent.Ecto.UserIdentities.Schema.Fields","doc":"Handles the Ecto schema fields for user.","ref":"PowAssent.Ecto.UserIdentities.Schema.Fields.html"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.Fields.assocs/1","doc":"List of associations for the ecto schema.","ref":"PowAssent.Ecto.UserIdentities.Schema.Fields.html#assocs/1"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.Fields.attrs/1","doc":"List of attributes for the ecto schema.","ref":"PowAssent.Ecto.UserIdentities.Schema.Fields.html#attrs/1"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.Fields.indexes/1","doc":"List of indexes for the ecto schema.","ref":"PowAssent.Ecto.UserIdentities.Schema.Fields.html#indexes/1"},{"type":"module","title":"PowAssent.Ecto.UserIdentities.Schema.Migration","doc":"Generates schema migration content.","ref":"PowAssent.Ecto.UserIdentities.Schema.Migration.html"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.Migration.new/3","doc":"Generates migration schema map.","ref":"PowAssent.Ecto.UserIdentities.Schema.Migration.html#new/3"},{"type":"module","title":"PowAssent.Ecto.UserIdentities.Schema.Module","doc":"Generates schema module content.","ref":"PowAssent.Ecto.UserIdentities.Schema.Module.html"},{"type":"module","title":"Configuration options - PowAssent.Ecto.UserIdentities.Schema.Module","doc":"* `:binary_id` - if the schema module should use binary id, default nil.","ref":"PowAssent.Ecto.UserIdentities.Schema.Module.html#module-configuration-options"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.Module.gen/1","doc":"Generates schema module file content.","ref":"PowAssent.Ecto.UserIdentities.Schema.Module.html#gen/1"},{"type":"function","title":"PowAssent.Ecto.UserIdentities.Schema.Module.new/4","doc":"Generates a schema module map.","ref":"PowAssent.Ecto.UserIdentities.Schema.Module.html#new/4"},{"type":"module","title":"PowAssent.Phoenix.Messages","doc":"Module that handles messages for PowAssent.\n\nTo override messages from PowAssent, the method name has to start with the\n`pow_assent_`. So the `signed_in/1` method, should be written as\n`pow_assent_signed_in/1`.","ref":"PowAssent.Phoenix.Messages.html"},{"type":"module","title":"Usage - PowAssent.Phoenix.Messages","doc":"defmodule MyAppWeb.Pow.Messages do\n      use Pow.Phoenix.Messages\n      use Pow.Extension.Phoenix.Messages,\n        extensions: [PowAssent]\n\n      import MyAppWeb.Gettext\n\n      def pow_assent_signed_in(conn) do\n        provider = Phoenix.Naming.humanize(conn.params[\"provider\"])\n\n        gettext(\"You've been signed in with %{provider}.\")\n      end\n    end\n\nRemember to update Pow configuration with\n`messages_backend: MyAppWeb.Pow.Messages`.\n\nSee `Pow.Extension.Phoenix.Messages` for more.","ref":"PowAssent.Phoenix.Messages.html#module-usage"},{"type":"function","title":"PowAssent.Phoenix.Messages.account_already_bound_to_other_user/1","doc":"Message for when provider account already exists for another user.","ref":"PowAssent.Phoenix.Messages.html#account_already_bound_to_other_user/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.authentication_has_been_removed/1","doc":"Message for when provider identity has been deleted for user.","ref":"PowAssent.Phoenix.Messages.html#authentication_has_been_removed/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.could_not_sign_in/1","doc":"Message for when user couldn't be signed in.","ref":"PowAssent.Phoenix.Messages.html#could_not_sign_in/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.identity_cannot_be_removed_missing_user_password/1","doc":"Message for when user password is required to delete provider identity.","ref":"PowAssent.Phoenix.Messages.html#identity_cannot_be_removed_missing_user_password/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.invalid_request/1","doc":"Message for invalid request.","ref":"PowAssent.Phoenix.Messages.html#invalid_request/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.login_with_provider/1","doc":"Message for provider login button.","ref":"PowAssent.Phoenix.Messages.html#login_with_provider/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.remove_provider_authentication/1","doc":"Message for provider identity deletion button.","ref":"PowAssent.Phoenix.Messages.html#remove_provider_authentication/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.signed_in/1","doc":"Message for when user has signed in.\n\nDefaults to nil.","ref":"PowAssent.Phoenix.Messages.html#signed_in/1"},{"type":"function","title":"PowAssent.Phoenix.Messages.user_has_been_created/1","doc":"Message for when user has signed up successfully.\n\nDefaults to nil.","ref":"PowAssent.Phoenix.Messages.html#user_has_been_created/1"},{"type":"module","title":"PowAssent.Phoenix.ReauthorizationPlugHandler","doc":"Used with `PowAssent.Plug.Reauthorization`.","ref":"PowAssent.Phoenix.ReauthorizationPlugHandler.html"},{"type":"module","title":"Example - PowAssent.Phoenix.ReauthorizationPlugHandler","doc":"plug PowAssent.Plug.Reauthorization,\n    handler: PowAssent.Phoenix.ReauthorizationPlugHandler","ref":"PowAssent.Phoenix.ReauthorizationPlugHandler.html#module-example"},{"type":"function","title":"PowAssent.Phoenix.ReauthorizationPlugHandler.clear_reauthorization?/2","doc":"Checks if the reauthorization should be cleared.\n\nReturns true when the request path matches delete session route.","ref":"PowAssent.Phoenix.ReauthorizationPlugHandler.html#clear_reauthorization?/2"},{"type":"function","title":"PowAssent.Phoenix.ReauthorizationPlugHandler.reauthorize/3","doc":"Reauthorize callback.\n\nRedirects the user to the authorization path where they will be redirected to\nthe provider. The `request_path` is automatically appended to uri query if\nfound in params.\n\nSee `PowAssent.Plug.Reauthorization` for more.","ref":"PowAssent.Phoenix.ReauthorizationPlugHandler.html#reauthorize/3"},{"type":"function","title":"PowAssent.Phoenix.ReauthorizationPlugHandler.reauthorize?/2","doc":"Checks if the user should be reauthorized.\n\nReturns true when the request path matches\n`Pow.Phoenix.Routes.user_not_authenticated_path/1`.","ref":"PowAssent.Phoenix.ReauthorizationPlugHandler.html#reauthorize?/2"},{"type":"module","title":"PowAssent.Phoenix.Router","doc":"Handles Phoenix routing for PowAssent.","ref":"PowAssent.Phoenix.Router.html"},{"type":"module","title":"Usage - PowAssent.Phoenix.Router","doc":"Configure `lib/my_project_web/router.ex` the following way:\n\n    defmodule MyAppWeb.Router do\n      use MyAppWeb, :router\n      use Pow.Phoenix.Router\n      use PowAssent.Phoenix.Router\n\n      # ...\n\n      pipeline :skip_csrf_protection do\n        plug :accepts, [\"html\"]\n        plug :fetch_session\n        plug :fetch_flash\n        plug :put_secure_browser_headers\n      end\n\n      scope \"/\" do\n        pipe_through :skip_csrf_protection\n\n        pow_assent_authorization_post_callback_routes()\n      end\n\n      scope \"/\" do\n        pipe_through :browser\n\n        pow_routes()\n        pow_assent_routes()\n      end\n\n      # ...\n    end\n\nThe `:skip_csrf_protection` pipeline and\n`pow_assent_authorization_post_callback_routes/0` call is only necessary if\nyou have strategies using POST callback such as `Assent.Strategy.Apple`. The default\nCSRF protection in Phoenix has to be skipped when using POST callback.","ref":"PowAssent.Phoenix.Router.html#module-usage"},{"type":"macro","title":"PowAssent.Phoenix.Router.pow_assent_routes/0","doc":"PowAssent router macro.\n\nUse this macro to define the PowAssent routes.","ref":"PowAssent.Phoenix.Router.html#pow_assent_routes/0"},{"type":"macro","title":"Example - PowAssent.Phoenix.Router.pow_assent_routes/0","doc":"scope \"/\" do\n      pow_assent_routes()\n    end","ref":"PowAssent.Phoenix.Router.html#pow_assent_routes/0-example"},{"type":"exception","title":"PowAssent.Config.ConfigError","doc":"","ref":"PowAssent.Config.ConfigError.html"},{"type":"extras","title":"","doc":"# ![PowAssent](assets/logo-full.svg)\n\n[![Github CI](https://github.com/pow-auth/pow_assent/workflows/CI/badge.svg)](https://github.com/pow-auth/pow_assent/actions?query=workflow%3ACI)\n[![hexdocs.pm](https://img.shields.io/badge/api-docs-green.svg?style=flat)](https://hexdocs.pm/pow_assent)\n[![hex.pm](https://img.shields.io/hexpm/v/pow_assent.svg?style=flat)](https://hex.pm/packages/pow_assent)\n\n\nUse Google, Github, Twitter, Facebook, or add your custom strategy for authorization to your Pow enabled Phoenix app.","ref":"README.html"},{"type":"extras","title":"Features - ","doc":"* Collects required user id field from the user if the user id is missing from the provider\n* Multiple providers can be used for accounts\n  * When removing authentication, user is validated for password or alternative provider\n* You can add your custom strategy with ease\n* Includes all strategies from [`Assent`](https://github.com/pow-auth/assent):\n  * OAuth 1.0 - `Assent.Strategy.OAuth`\n  * OAuth 2.0 - `Assent.Strategy.OAuth2`\n  * OIDC - `Assent.Strategy.OIDC`\n  * Apple Sign In - `Assent.Strategy.Apple`\n  * Auth0 - `Assent.Strategy.Auth0`\n  * Azure AD - `Assent.Strategy.AzureAD`\n  * Basecamp - `Assent.Strategy.Basecamp`\n  * Discord - `Assent.Strategy.Discord`\n  * Facebook - `Assent.Strategy.Facebook`\n  * Github - `Assent.Strategy.Github`\n  * Gitlab - `Assent.Strategy.Gitlab`\n  * Google - `Assent.Strategy.Google`\n  * Instagram - `Assent.Strategy.Instagram`\n  * Slack - `Assent.Strategy.Slack`\n  * Twitter - `Assent.Strategy.Twitter`\n  * VK - `Assent.Strategy.VK`\n  * LINE Login - `Assent.Strategy.LINE`","ref":"README.html#features"},{"type":"extras","title":"Installation - ","doc":"Add PowAssent to your list of dependencies in `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:pow_assent, \"~> 0.4.18\"},\n\n    # Optional, but recommended for SSL validation with :httpc adapter\n    {:certifi, \"~> 2.4\"},\n    {:ssl_verify_fun, \"~> 1.1\"},\n    # ...\n  ]\nend\n```\n\nRun `mix deps.get` to install it.","ref":"README.html#installation"},{"type":"extras","title":"Getting started - ","doc":"#","ref":"README.html#getting-started"},{"type":"extras","title":"Set up Pow - ","doc":"It's required to set up [Pow](https://github.com/pow-auth/pow#phoenix-app) first. You can [run these quick setup](guides/set_up_pow.md) instructions if Pow hasn't already been set up.\n\nIf your user schema uses binary id, then run the PowAssent mix task(s) with the `--binary-id` flag.\n\n#","ref":"README.html#set-up-pow"},{"type":"extras","title":"Set up PowAssent - ","doc":"Install the necessary files:\n\n```bash\nmix pow_assent.install\n```\n\nThis will add the following files to your app:\n\n```bash\nLIB_PATH/user_identities/user_identity.ex\nPRIV_PATH/repo/migrations/TIMESTAMP_create_user_identities.ex\n```\n\nAnd also update the following files:\n\n```bash\nCONTEXT_PATH/users/user.ex\nWEB_PATH/router.ex\n```\n\nRun migrations with `mix setup`. The following routes will be available in your app:\n\n```elixir\nGET     /auth/:provider/new                    PowAssent.Phoenix.AuthorizationController :new\nDELETE  /auth/:provider                        PowAssent.Phoenix.AuthorizationController :delete\nGET     /auth/:provider/callback               PowAssent.Phoenix.AuthorizationController :callback\nGET     /auth/:provider/add-user-id            PowAssent.Phoenix.RegistrationController :add_user_id\nPOST    /auth/:provider/create                 PowAssent.Phoenix.RegistrationController :create\n```\n\n#","ref":"README.html#set-up-powassent"},{"type":"extras","title":"Modified Pow templates - ","doc":"If you're modifying the Pow templates, then you have to generate the PowAssent template too:\n\n```elixir\nmix pow_assent.phoenix.gen.templates\n```\n\nOtherwise, Pow will raise an error about missing template when the user id field template is shown.\n\n#","ref":"README.html#modified-pow-templates"},{"type":"extras","title":"Provider links - ","doc":"You can use helpers from `PowAssent.Phoenix.HTML.CoreComponents` to render provider links:\n\n```elixir\n# Minimal\n \n\n# With styling\n \n   \n    <:authorization_link :let={provider} class=\"block rounded-lg bg-zinc-600 hover:bg-zinc-700 py-2 px-3 text-sm font-semibold leading-6 text-white w-full text-center\">\n      <%= Phoenix.Naming.humanize(provider) %>  → \n    </:authorization_link>\n   \n \n```\n\nThis can be used in the `WEB_PATH/controllers/pow/session_html/new.html.heex`, `WEB_PATH/controllers/pow/registration_html/new.html.heex` and `WEB_PATH/controllers/pow/registration_html/edit.html.heex` templates. You may want to import or alias the module in your web module.\n\nBy default \"Sign in with PROVIDER\" link is shown. A \"Remove PROVIDER authentication\" link will be shown instead if the user is signed in and the user already is authorized with the provider.\n\nYou can also use `<.authorization_link conn={@conn} provider={provider} />` and `<.deauthorization_link conn={@conn} provider={provider} />` to generate a link for a single provider.\n\n#","ref":"README.html#provider-links"},{"type":"extras","title":"Setting up a provider - ","doc":"[Assent](https://github.com/pow-auth/assent) provides many strategies that you can use. Let's go through how to set up the Github strategy.\n\nFirst, register [a new app on Github](https://github.com/settings/applications/new) and add `http://localhost:4000/auth/github/callback` as the callback URL. Then add the following to `config/config.exs` and add the client id and client secret (for production keys you would want to set this in `config/prod.secret.exs`):\n\n```elixir\nconfig :my_app, :pow_assent,\n  providers: [\n    github: [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      client_secret: \"REPLACE_WITH_CLIENT_SECRET\",\n      strategy: Assent.Strategy.Github\n    ]\n  ]\n```\n\nNow start (or restart) your Phoenix app, and visit `http://localhost:4000/auth/github/new`.\n\n##","ref":"README.html#setting-up-a-provider"},{"type":"extras","title":"Nonce - ","doc":"For OIDC requests a nonce may be required. PowAssent can automatically generate the nonce if you pass `nonce: true` in the PowAssent configuration:\n\n```elixir\nconfig :my_app, :pow_assent,\n  providers: [\n    example: [\n      client_id: \"REPLACE_WITH_CLIENT_ID\",\n      base_url: \"https://server.example.com\",\n      authorization_params: [scope: \"user:read user:write\"],\n      nonce: true,\n      strategy: Assent.Strategy.OIDC\n    ]\n  ]\n```","ref":"README.html#nonce"},{"type":"extras","title":"Custom provider - ","doc":"You can add your own custom strategy. See [\"Custom Provider\" section of Assent readme](https://github.com/pow-auth/assent#custom-provider) for more.","ref":"README.html#custom-provider"},{"type":"extras","title":"I18n - ","doc":"The template can be generated and modified to use your Gettext module with `mix pow_assent.phoenix.gen.templates`\n\nFor flash messages, you should add them to your `Pow.Phoenix.Messages` module the same way as all Pow extension flash messages:\n\n```elixir\ndefmodule MyAppWeb.Pow.Messages do\n  use Pow.Phoenix.Messages\n  use Pow.Extension.Phoenix.Messages,\n    extensions: [PowAssent]\n\n  import MyAppWeb.Gettext\n\n  # ...\n\n  def pow_assent_signed_in(conn) do\n    provider = Phoenix.Naming.humanize(conn.params[\"provider\"])\n\n    gettext(\"You've been signed in with %{provider}.\", provider)\n  end\nend\n```\n\nAdd `messages_backend: MyAppWeb.Pow.Messages` to your Pow configuration. You can find all messages in `PowAssent.Phoenix.Messages`.","ref":"README.html#i18n"},{"type":"extras","title":"Populate fields - ","doc":"To populate fields in your user struct that are fetched from the provider, you can override the `user_identity_changeset/4` method to cast them:\n\n```elixir\ndefmodule MyApp.Users.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema\n  use PowAssent.Ecto.Schema\n\n  schema \"users\" do\n    field :custom_field, :string\n\n    pow_user_fields()\n\n    timestamps()\n  end\n\n  def user_identity_changeset(user_or_changeset, user_identity, attrs, user_id_attrs) do\n    user_or_changeset\n    |> Ecto.Changeset.cast(attrs, [:custom_field])\n    |> pow_assent_user_identity_changeset(user_identity, attrs, user_id_attrs)\n  end\nend\n```\n\nThe fields available can be found in the `normalize/2` method of the strategy module.","ref":"README.html#populate-fields"},{"type":"extras","title":"Disable registration - ","doc":"You can disable registration by using `pow_assent_authorization_routes/0` instead of `pow_assent_routes/0` in `router.ex`:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Pow.Phoenix.Router\n  use PowAssent.Phoenix.Router\n\n  # ...\n\n  pipeline :skip_csrf_protection do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_flash\n    plug :put_secure_browser_headers\n  end\n\n  # ...\n\n  scope \"/\" do\n    pipe_through :skip_csrf_protection\n\n    pow_assent_authorization_post_callback_routes()\n  end\n\n  scope \"/\" do\n    pipe_through :browser\n\n    pow_routes()\n    pow_assent_authorization_routes()\n  end\n\n  # ...\nend\n```\n\nPowAssent will pick it up in the authorization flow, and prevent creating a user if the registration path is missing.","ref":"README.html#disable-registration"},{"type":"extras","title":"Cookie options - ","doc":"Cookie options are passed on to `Plug.Conn.html.put_resp_cookie/4` and can be set by using the `:auth_session_cookie_opts` setting (and `:reauthorization_cookie_opts` for the `PowAssent.Plug.Reauthorization` plug):\n\n```elixir\nconfig :my_app, :pow_assent,\n    auth_session_cookie_opts: [\n      secure: true,\n      extra: \"SameSite=Strict\"\n    ]\n\n    # If you are using the reathorization plug:\n    # reauthorization_cookie_opts: [\n    #   secure: true\n    # ]\n  ]\n]\n```","ref":"README.html#cookie-options"},{"type":"extras","title":"HTTP Adapter - ","doc":"By default Erlangs built-in `:httpc` is used for requests. SSL verification is automatically enabled when `:certifi` and `:ssl_verify_fun` packages are available. `:httpc` only supports HTTP/1.1.\n\nIf you would like HTTP/2 support, you should consider adding [`Mint`](https://github.com/elixir-mint/mint) to your project.\n\nUpdate `mix.exs`:\n\n```elixir\ndefp deps do\n  [\n    # ...\n    {:mint, \"~> 1.0\"},\n    {:castore, \"~> 0.1.0\"}, # Required for SSL validation\n    # ...\n  ]\nend\n```\n\nUpdate the PowAssent configuration with:\n\n```elixir\nconfig :my_app, :pow_assent,\n  http_adapter: Assent.HTTPAdapter.Mint\n```","ref":"README.html#http-adapter"},{"type":"extras","title":"Different module naming - ","doc":"PowAssent works by the assumption that you name your schema modules in the form of `[App].[Context].[Schema]`. If you have a different module naming, all you have to do is to add the `has_many` association to your user module like so:\n\n```elixir\ndefmodule MyApp.Lib.User do\n  use Ecto.Schema\n  use Pow.Ecto.Schema\n  use PowAssent.Ecto.Schema\n\n  schema \"users\" do\n    has_many :user_identities,\n      MyApp.Lib.UserIdentity,\n      on_delete: :delete_all,\n      foreign_key: :user_id\n\n    pow_user_fields()\n\n    # ...\n\n    timestamps()\n  end\n\n  # ..\nend\n```\n\nOtherwise you'll get an error that reads:\n\n```elixir\nwarning: invalid association `user_identities` in schema MyApp.Lib.User: associated schema MyApp.UserIdentities.UserIdentity does not exist\n```","ref":"README.html#different-module-naming"},{"type":"extras","title":"Callback URL with HTTPS behind proxy - ","doc":"PowAssent uses the Phoenix URL generator to generate the callback URL used in OAuth and OIDC flows. If you run your Phoenix app behind a proxy, then you should ensure that HTTPS endpoints are generated:\n\n```elixir\nconfig :my_app, MyAppWeb.Endpoint,\n  # ..,\n  url: [scheme: \"https\", host: \"example.com\", port: 443]\n```","ref":"README.html#callback-url-with-https-behind-proxy"},{"type":"extras","title":"Pow Extensions - ","doc":"#","ref":"README.html#pow-extensions"},{"type":"extras","title":"PowEmailConfirmation - ","doc":"The e-mail fetched from the provider params is assumed confirmed if an `email_verified` key with value `true` also exists in the params. In that case the user will have `:email_confirmed_at` set. If `email_verified` isn't `true` in the provider params, or the user provides the e-mail, then the user will have to confirm their e-mail before they can sign in.\n\nTo prevent user enumeration attacks whenever there is a unique constraint error for e-mail the user will see confirmation required error message. However if `email_verified` is `true` in the provider params they will be see the form with changeset error. The same happens if `pow_prevent_information_leak: false` is set in `conn.private`.\n\n#","ref":"README.html#powemailconfirmation"},{"type":"extras","title":"PowInvitation - ","doc":"PowAssent works out of the box with PowInvitation.\n\nProvider links will have an `invitation_token` query param if an invited user exists in the connection. This will be used in the authorization callback flow to load the invited user. If a user identity is created, the invited user will have the `:invitation_accepted_at` set.\n\n#","ref":"README.html#powinvitation"},{"type":"extras","title":"PowPersistentSession - ","doc":"PowAssent doesn't support `PowPersistentSession`, as it's recommended to let the provider handle persistent session. `PowAssent.Plug.Reauthorization` can be used for this purpose.\n\nYou can enable the reauthorization plug in your `WEB_PATH/router.ex` by adding it to a pipeline:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  # ...\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_flash\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n    plug PowAssent.Plug.Reauthorization,\n      handler: PowAssent.Phoenix.ReauthorizationPlugHandler\n  end\n\n  # ...\nend\n```\n\nYou can also enable `PowPersistentSession` by using the `PowAssent.Plug.put_create_session_callback/2` method:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  # ...\n\n  pipeline :browser do\n    plug :accepts, [\"html\"]\n    plug :fetch_session\n    plug :fetch_flash\n    plug :protect_from_forgery\n    plug :put_secure_browser_headers\n    plug :pow_assent_persistent_session\n  end\n\n  defp pow_assent_persistent_session(conn, _opts) do\n    PowAssent.Plug.put_create_session_callback(conn, fn conn, _provider, _config ->\n      PowPersistentSession.Plug.create(conn, Pow.Plug.current_user(conn))\n    end)\n  end\n\n  # ...\n```","ref":"README.html#powpersistentsession"},{"type":"extras","title":"Security concerns - ","doc":"All sessions created through PowAssent provider authentication are temporary. However, it's a good idea to do some housekeeping in your app and make sure that you have the level of security as warranted by the scope of your app. That may include requiring users to re-authenticate before viewing or editing their user details.","ref":"README.html#security-concerns"},{"type":"extras","title":"LICENSE - ","doc":"(The MIT License)\n\nCopyright (c) 2018-2019 Dan Schultzer & the Contributors\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the 'Software'), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED 'AS IS', WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"README.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog","ref":"CHANGELOG.html"},{"type":"extras","title":"v0.4.18 (2024-02-17) - Changelog","doc":"Now supports Phoenix HTML 4.0.\n\n`PowAssent.Phoenix.ViewHelpers` has been replaced with `PowAssent.Phoenix.HTML.CoreComponents` for Phoenix 1.7. The following functions be used in place of the previous view helper functions:\n\n- `PowAssent.Phoenix.HTML.CoreComponents.provider_links/1`\n- `PowAssent.Phoenix.HTML.CoreComponents.authorization_link/1`\n- `PowAssent.Phoenix.HTML.CoreComponents.deauthorization_link/1`\n\n#","ref":"CHANGELOG.html#v0-4-18-2024-02-17"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowAssent.Phoenix.HTML.CoreComponents`] added with template functions for authorization links\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Deprecations - Changelog","doc":"* [`PowAssent.Phoenix.ViewHelpers`] has been deprecated and removed from Phoenix 1.7","ref":"CHANGELOG.html#deprecations"},{"type":"extras","title":"v0.4.17 (2023-03-28) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-4-17-2023-03-28"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowAssent.Phoenix.AuthorizationController`] Now logs error for when user can't be created\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowAssent.Phoenix.AuthorizationController`] Fixed bug where registration path couldn't be found due to no route helpers","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v0.4.16 (2023-03-21) - Changelog","doc":"Now uses Phoenix 1.7 components templating and requires Pow 1.0.29.\n\n#","ref":"CHANGELOG.html#v0-4-16-2023-03-21"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`Mix.Tasks.Pow.Ecto.Install`] Now injects `CONTEXT_PATH/users/user.ex`\n* [`Mix.Tasks.Pow.Phoenix.Install`] Added to inject `WEB_PATH/router.ex`","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"v0.4.15 (2023-03-20) - Changelog","doc":"Now supports Phoenix 1.7.","ref":"CHANGELOG.html#v0-4-15-2023-03-20"},{"type":"extras","title":"v0.4.14 (2023-01-22) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-4-14-2023-01-22"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowAssent.Plug`] Fixed bug in `callback_upsert/4` where users couldn't sign in with disabled registration\n* `:phoenix` removed from the compilers","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v0.4.13 (2022-04-27) - Changelog","doc":"Now supports `ecto_sql` 3.8.x and requires Elixir 1.11+.\n\n* Added [dynamic strategy configuration guide](guides/dynamic_strategy_configuration.md)","ref":"CHANGELOG.html#v0-4-13-2022-04-27"},{"type":"extras","title":"v0.4.12 (2021-09-30) - Changelog","doc":"Now supports Phoenix 1.6.x.","ref":"CHANGELOG.html#v0-4-12-2021-09-30"},{"type":"extras","title":"v0.4.11 (2021-07-14) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-4-11-2021-07-14"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowAssent.Ecto.UserIdentities.Context`] The macro no longer throws warning in Elixir 1.12","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v0.4.10 (2020-11-24) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-4-10-2020-11-24"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowAssent.Plug`] Fixed bug where the `:cache_store_backend` was not being loaded from the application environment correctly","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"v0.4.9 (2020-10-18) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-4-9-2020-10-18"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowAssent.Plug`] Now stores a session cookie instead of using `Plug.Session` to prevent SameSite policy issue in `form_post` flow\n* [`PowAssent.Plug`] `PowAssent.Plug.callback/4` now adds the `userinfo` with claims to the user identity params","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"v0.4.8 (2020-05-18) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-4-8-2020-05-18"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowAssent.Plug`] Added `PowAssent.Plug.put_create_session_callback/2`\n* [`PowAssent.Plug`] Added `PowAssent.Plug.fetch_config/1`\n* [`PowAssent.Plug`] Now calls create session callbacks set with `PowAssent.Plug.put_create_session_callback/2` when a session is created\n* [`PowAssent.Plug.Reauthorization`] Added plug to enable reauthorization\n* [`PowAssent.Phoenix.AuthorizationController`] Now instead of raising an exception for strategy errors, the user is redirected to the sign in page with a generic error message\n* [`PowAssent.Config`] Added `PowAssent.Config.merge_provider_config/3`\n* [`PowAssent.Plug`] Added `PowAssent.Plug.merge_provider_config/3`","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"v0.4.7 (2020-04-22) - Changelog","doc":"Now support Phoenix 1.5 and requires Pow `~> 1.0.19` and Elixir 1.7.","ref":"CHANGELOG.html#v0-4-7-2020-04-22"},{"type":"extras","title":"v0.4.6 (2020-02-16) - Changelog","doc":"The callback flow has been changed so sessions are now stored in the backend cache with `PowAssent.Store.SessionCache` instead of using `Plug.Session`. This prevents exposure of sensitive data, as the only thing stored in the Plug session is a random UUID.\n\nUpdated Pow requirement to `~> 1.0.17`.\n\n#","ref":"CHANGELOG.html#v0-4-6-2020-02-16"},{"type":"extras","title":"Enhancements - Changelog","doc":"* [`PowAssent.Plug`] Added `PowAssent.Plug.change_user/4`\n* [`PowAssent.Operations`] Added `PowAssent.Operations.user_identity_changeset/4`\n* [`PowAssent.Phoenix.AuthorizationController`] Now prevents user enumeration attack using `PowEmailConfirmation.Phoenix.ControllerCallbacks` when `PowEmailConfirmation` extension is enabled\n* [`PowAssent.Phoenix.AuthorizationController`] Now stores `:changeset` in session when redirecting to `:add_user_id` page\n* [`PowAssent.Phoenix.RegistrationController`] Now prevents user enumeration attack using `PowEmailConfirmation.Phoenix.ControllerCallbacks` when `PowEmailConfirmation` extension is enabled\n* [`PowAssent.Phoenix.RegistrationController`] Now uses `:changeset` stored in the session when rendering `:add_user_id` page\n* [`PowAssent.Plug`] Moved business logic away from `PowAssent.Phoenix.AuthorizationController` into `PowAssent.Plug.callback_upsert/4` that will authenticate, upsert user identity, or create user\n* [`PowAssent.Store.SessionCache`] Added session store module\n* [`PowAssent.Plug`] Added `PowAssent.Plug.init_session/1`\n* [`PowAssent.Plug`] Added `PowAssent.Plug.put_session/3`\n* [`PowAssent.Plug`] Added `PowAssent.Plug.delete_session/2`\n\n#","ref":"CHANGELOG.html#enhancements"},{"type":"extras","title":"Bug fixes - Changelog","doc":"* [`PowAssent.Ecto.Schema`] Fixed issue in `PowAssent.Ecto.Schema.changeset/2` where confirmation token was not set thus allowing users with unconfirmed email to sign in\n\n#","ref":"CHANGELOG.html#bug-fixes"},{"type":"extras","title":"Documentation - Changelog","doc":"* Added [legacy migration guide](guides/legacy_migration.md)\n* Added [API guide](guides/api.md)","ref":"CHANGELOG.html#documentation"},{"type":"extras","title":"v0.4.5 (2019-12-06) - Changelog","doc":"* [`PowAssent.Phoenix.AuthorizationController`] Now supports `:request_path` param so the user will be redirected back to `:request_path` after successful authorization\n* [`PowAssent.Phoenix.ViewHelpers`] `PowAssent.Phoenix.ViewHelpers.authorization_link/3` now adds `:request_path` to the query param if assigned to the conn\n* [`PowAssent.Phoenix.ViewHelpers`] `PowAssent.Phoenix.ViewHelpers.authorization_link/3`, `PowAssent.Phoenix.ViewHelpers.deauthorization_link/3`, and `PowAssent.Phoenix.ViewHelpers.provider_links/2` now accepts keyword list with options to be passed on to the link generation","ref":"CHANGELOG.html#v0-4-5-2019-12-06"},{"type":"extras","title":"v0.4.4 (2019-11-22) - Changelog","doc":"**Note:** This release contains an important security fix.\n\n* [`PowAssent.Plug`] Now uses `String.to_existing_atom/1` in `PowAssent.Plug.providers_for_current_user/1`\n* [`PowAssent.Plug`] Fixed security issue by removing `String.to_atom/1` for user provided binary in `PowAssent.Plug.authorize_url/3` and `PowAssent.Plug.callback/4`\n* [`PowAssent.Config`] `PowAssent.Config.get_provider_config/2` now accepts binary provider","ref":"CHANGELOG.html#v0-4-4-2019-11-22"},{"type":"extras","title":"v0.4.3 (2019-11-20) - Changelog","doc":"* Removed `:phoenix_html` dependency requirement\n* Added Pow minimum requirement `~> 1.0.15`\n* Use `Pow.Extension.Base` macro for new extension setup","ref":"CHANGELOG.html#v0-4-3-2019-11-20"},{"type":"extras","title":"v0.4.2 (2019-11-13) - Changelog","doc":"* Added support for POST callback from provider:\n  * Added `pow_assent_authorization_post_callback_routes/0` macro to `PowAssent.Phoenix.Router`\n  * Added `:skip_csrf_protection` pipeline example and scope with `pow_assent_authorization_post_callback_routes/0` call to the docs\n  * Use `Pow.Phoenix.Router` macros to dynamically filter duplicate routes","ref":"CHANGELOG.html#v0-4-2-2019-11-13"},{"type":"extras","title":"v0.4.1 (2019-10-08) - Changelog","doc":"* Use Assent `v0.1.2` and set `:redirect_uri` in config for OAuth 2.0 callback phase","ref":"CHANGELOG.html#v0-4-1-2019-10-08"},{"type":"extras","title":"v0.4.0 (2019-10-06) - Changelog","doc":"**This release consists of major breaking changes.**\n\nYou'll have to change the `:strategy` setting in your provider configurations. For the most part it would just consists of renaming `PowAssent.Strategy.STRATEGY` to `Assent.Strategy.STRATEGY`.\n\nIf you have custom built strategies, you should can use `Assent.Strategy.normalize_userinfo/2` to conform the userinfo response from the API. `sub` is now expected instead of `uid`.\n\n#","ref":"CHANGELOG.html#v0-4-0-2019-10-06"},{"type":"extras","title":"Changes - Changelog","doc":"* Use [`:assent` package](https://github.com/pow-auth/assent) for strategies. The following modules has been removed in favor of `Assent` modules:\n\n  * `PowAssent.CallbackError`\n  * `PowAssent.CallbackCSRFError`\n  * `PowAssent.RequestError`\n  * `PowAssent.ConfigurationError`\n  * `PowAssent.HTTPAdapter`\n  * `PowAssent.HTTPAdapter.Httpc`\n  * `PowAssent.HTTPAdapter.Mint`\n  * `PowAssent.Strategy.Auth0`\n  * `PowAssent.Strategy.AzureOAuth2`\n  * `PowAssent.Strategy.Basecamp`\n  * `PowAssent.Strategy.Discord`\n  * `PowAssent.Strategy.Facebook`\n  * `PowAssent.Strategy.Github`\n  * `PowAssent.Strategy.Gitlab`\n  * `PowAssent.Strategy.Google`\n  * `PowAssent.Strategy.Instagram`\n  * `PowAssent.Strategy.OAuth`\n  * `PowAssent.Strategy.OAuth.Base`\n  * `PowAssent.Strategy.OAuth2`\n  * `PowAssent.Strategy.OAuth2.Base`\n  * `PowAssent.Strategy.Slack`\n  * `PowAssent.Strategy.Twitter`\n  * `PowAssent.Strategy.VK`\n  * `PowAssent.Strategy`\n\n* Callback params now conforms to [OpenID Connect Core 1.0 Standard Claims spec](https://openid.net/specs/openid-connect-core-1_0.html#rfc.section.5.1). During the callback phase, the following param keys will be renamed:\n\n  * `sub` to `uid`\n  * `preferred_username` to `username`\n\n* The e-mail is no longer considered confirmed unless the callback params has an `email_verified` key set to true\n\n* `PowAssent.Plug.authorize_url/3` generates a random nonce if `nonce: true` is set in the provider configuration\n\n* Support for OpenID Connect and Apple Sign In through Assent","ref":"CHANGELOG.html#changes"},{"type":"extras","title":"v0.3.2 (2019-08-25) - Changelog","doc":"* All links in docs generated with `mix docs` and on [hexdocs.pm](http://hexdocs.pm/pow/) now works\n* Generated docs now uses lower case file name except for `README` and `CHANGELOG`\n* Added Auth0 strategy\n* Added Gitlab strategy","ref":"CHANGELOG.html#v0-3-2-2019-08-25"},{"type":"extras","title":"v0.3.1 (2019-06-05) - Changelog","doc":"* Added Pow minimum requirement `~> 1.0.9`\n* Added repo `:prefix` support\n* User identities are now upserted on authorization so additional params can be updated on authorization request. Following methods has been deprecated:\n  * `PowAssent.Ecto.UserIdentities.Context.create/3` in favor of `PowAssent.Ecto.UserIdentities.Context.upsert/3`\n  * `MyApp.UserIdentities.create/2` in favor of `MyApp.UserIdentities.upsert/2`\n  * `MyApp.UserIdentities.pow_assent_create/2` in favor of `MyApp.UserIdentities.upsert/2`\n  * `PowAssent.Operations.create/3` in favor of `PowAssent.Operations.upsert/3`\n  * `PowAssent.Plug.create_identity/2` in favor of `PowAssent.Plug.upsert_identity/2`\n* Use `Pow.Plug.get_plug/1` instead of pulling `:mod` from the config\n* Fixed so `uid` can be an integer value in `PowAssent.Ecto.UserIdentities.Context`. Strategies are no longer expected to convert the `uid` value to binary. The following methods will accepts integer `uid`:\n  * `PowAssent.Ecto.UserIdentities.Context.get_user_by_provider_uid/3`\n  * `PowAssent.Ecto.UserIdentities.Context.upsert/3`\n  * `PowAssent.Ecto.UserIdentities.Context.create_user/4`\n* Fixed bug where invited user was not signed in after succesful authorization\n* Fixed bug where releases with Elixir 1.9.0 didn't have `:httpc` available","ref":"CHANGELOG.html#v0-3-1-2019-06-05"},{"type":"extras","title":"v0.3.0 (2019-05-19) - Changelog","doc":"* Added `PowAssent.Phoenix.ViewHelpers.authorization_link/2` and  `PowAssent.Phoenix.ViewHelpers.deauthorization_link/2`\n* Removed `PowAssent.Phoenix.ViewHelpers.provider_link/3`\n* Rewritten plug methods and controller handling so they now pass through additional params such as access token. This makes it possible to e.g. capture access tokens. Now there is a clear distinction between user identity params and user params, and most methods now accepts or returns two separate params. Following methods updated:\n  * `MyApp.UserIdentities.create/3` changed to `MyApp.UserIdentities.create/2`\n  * `MyApp.UserIdentities.pow_assent_create/3` changed to `MyApp.UserIdentities.pow_assent_create/2`\n  * `PowAssent.Ecto.UserIdentities.Context.create/4` changed to `PowAssent.Ecto.UserIdentities.Context.create/3`\n  * `MyApp.UserIdentities.create_user/4` changed to `MyApp.UserIdentities.create_user/3`\n  * `MyApp.UserIdentities.pow_assent_create_user/4` changed to `MyApp.UserIdentities.pow_assent_create_user/3`\n  * `PowAssent.Ecto.UserIdentities.Context.create_user/5` changed to `PowAssent.Ecto.UserIdentities.Context.create_user/4`\n  * `PowAssent.Operations.create/4` changed to `PowAssent.Operations.create/3`\n  * `PowAssent.Operations.create_user/5` changed to `PowAssent.Operations.create_user/4`\n  * `PowAssent.Plug.callback/4` now returns a tuple with `{:ok, user_identity_params, user_params, conn}`\n  * `PowAssent.Plug.authenticate/3` changed to `PowAssent.Plug.authenticate/2`\n  * `PowAssent.Plug.create_identity/3` changed to `PowAssent.Plug.create_identity/2`\n  * `PowAssent.Plug.create_user/4` now accepts `user_identity_params` instead of `provider` as second argument\n  * `PowAssent.Plug.create_user/4` now expects `user_identity_params` rather than `provider` as second argument","ref":"CHANGELOG.html#v0-3-0-2019-05-19"},{"type":"extras","title":"v0.2.4 (2019-04-25) - Changelog","doc":"* Fixed so OAuth 2.0 access token request params are in the POST body in accordance with RFC 6749","ref":"CHANGELOG.html#v0-2-4-2019-04-25"},{"type":"extras","title":"v0.2.3 (2019-04-09) - Changelog","doc":"* Added `:authorization_params` config option to `PowAssent.Strategy.OAuth`\n* Plug and Phoenix controller now handles `:session_params` rather than `:state` for any params that needs to be stored temporarily during authorization\n* Added handling of `oauth_token_secret` to OAuth strategies\n* Support any `:plug` version below `2.0.0`\n* Fixed bug in `mix pow_assent.ecto.gen.migration` task where `--binary-id` flag didn't generate correct migration\n* Support `:pow` version `1.0.5`","ref":"CHANGELOG.html#v0-2-3-2019-04-09"},{"type":"extras","title":"v0.2.2 (2019-03-25) - Changelog","doc":"* Fixed issue where user couldn't be created when PowEmailConfirmation was enabled","ref":"CHANGELOG.html#v0-2-2-2019-03-25"},{"type":"extras","title":"v0.2.1 (2019-03-16) - Changelog","doc":"* Improve mix task instructions","ref":"CHANGELOG.html#v0-2-1-2019-03-16"},{"type":"extras","title":"v0.2.0 (2019-03-09) - Changelog","doc":"#","ref":"CHANGELOG.html#v0-2-0-2019-03-09"},{"type":"extras","title":"Changes - Changelog","doc":"* Detached `Plug` from strategies\n* Moved callback registration/session logic from plug to controllers\n* Allow for disabling registration by setting just `pow_assent_authorize_routes/0` macro in router\n* Ensure only `:pow_assent_params` session value only can be read with the same provider param used for the callback\n* `token` now included in `PowAssent.Strategy.OAuth.callback/2` response\n* Use `account_already_bound_to_other_user/1` message for already taken user identity in `PowAssent.Phoenix.RegistrationController`\n\n#","ref":"CHANGELOG.html#changes"},{"type":"extras","title":"Update your custom strategies - Changelog","doc":"Strategies no longer has access to a `Plug.Conn` struct. If you use a custom strategy, please update it so it reflects this setup:\n\n```elixir\ndefmodule TestProvider do\n  @behaviour PowAssent.Strategy\n\n  @spec authorize_url(Keyword.t()) :: {:ok, %{url: binary()}} | {:error, term()}\n  def authorize_url(config) do\n    # Generate authorization url\n  end\n\n  @spec callback(Keyword.t(), map()) :: {:ok, %{user: map()}} | {:error, term()}\n  def callback(config, params) do\n    # Handle callback response\n  end\nend\n```","ref":"CHANGELOG.html#update-your-custom-strategies"},{"type":"extras","title":"v0.1.0 (2019-02-28) - Changelog","doc":"* Initial release","ref":"CHANGELOG.html#v0-1-0-2019-02-28"},{"type":"extras","title":"Set up Pow","doc":"# Set up Pow\n\nBe sure that you have [installed PowAssent](../README.md#installation) in `mix.exs` first.\n\nInstall the necessary files:\n\n```mix\nmix pow.install\n```\n\nAdd the following to `config/config.ex`:\n\n```elixir\nconfig :my_app, :pow,\n  user: MyApp.Users.User,\n  repo: MyApp.Repo\n```\n\nSet up `WEB_PATH/endpoint.ex` to enable session based authentication (`Pow.Plug.Session` is added after `Plug.Session`):\n\n```elixir\ndefmodule MyAppWeb.Endpoint do\n  use Phoenix.Endpoint, otp_app: :my_app\n\n  # ...\n\n  plug Plug.Session,\n    store: :cookie,\n    key: \"_my_app_key\",\n    signing_salt: \"secret\"\n\n  plug Pow.Plug.Session, otp_app: :my_app\n\n  # ...\nend\n```\n\nAdd Pow routes to `WEB_PATH/router.ex`:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n  use Pow.Phoenix.Router\n\n  # ...\n\n  pipeline :protected do\n    plug Pow.Plug.RequireAuthenticated,\n      error_handler: Pow.Phoenix.PlugErrorHandler\n  end\n\n  scope \"/\" do\n    pipe_through :browser\n\n    pow_routes()\n  end\n\n  # ...\n\n  scope \"/\", MyAppWeb do\n    pipe_through [:browser, :protected]\n\n    # Protected routes ...\n  end\nend\n```\n\nRun `mix ecto.setup` and you can now visit `http://localhost:4000/registration/new` to create a new user.","ref":"set_up_pow.html"},{"type":"extras","title":"Capture access token","doc":"# Capture access token\n\nBy default, access tokens are not recorded. If you wish to capture the access tokens to use for future you can add the field to your user identity table and update the user identity schema:\n\n```elixir\n# priv/repo/migrations/TIMESTAMP_add_access_token_to_user_identities.ex\ndefmodule PowAssent.Test.Ecto.Repo.Migrations.AddAccessTokenToUserIdentities do\n  use Ecto.Migration\n\n  def change do\n    alter table(:user_identities) do\n      add :access_token, :string\n      add :refresh_token, :string\n    end\n  end\nend\n```\n\n```elixir\n# lib/my_app/user_identities/user_identity.ex\ndefmodule MyApp.UserIdentities.UserIdentity do\n  use Ecto.Schema\n  use PowAssent.Ecto.UserIdentities.Schema,\n    user: MyApp.Users.User\n\n  schema \"user_identities\" do\n    field :access_token, :string\n    field :refresh_token, :string\n\n    pow_assent_user_identity_fields()\n\n    timestamps()\n  end\n\n  def changeset(user_identity_or_changeset, attrs) do\n    token_params = Map.get(attrs, \"token\", attrs)\n\n    user_identity_or_changeset\n    |> pow_assent_changeset(attrs)\n    |> Ecto.Changeset.cast(token_params, [:access_token, :refresh_token])\n    |> Ecto.Changeset.validate_required([:access_token])\n  end\nend\n```\n\nNow access tokens can be retrieved by loading the user identity:\n\n```elixir\nuser_identity = MyApp.Repo.get_by(MyApp.UserIdentities.UserIdentity, provider: provider, user_id: user.id)\n```","ref":"capture_access_token.html"},{"type":"extras","title":"Migrating from legacy system","doc":"# Migrating from legacy system\n\nA common setup with Ueberauth is to have provider details as columns in the `users` table. To migrate from that you should copy over the provider details to the `user_identities` table.\n\nThe below shows an example with a legacy system using facebook:\n\n```elixir\ndefmodule MyApp.Repo.Migrations.FacebookUserToUserIdentities do\n  use Ecto.Migration\n\n  import Ecto.Query\n  alias MyApp.Repo\n\n  def up do\n    create_user_identities()\n\n    alter table(:users) do\n      remove :facebook_id\n      remove :facebook_access_token\n    end\n  end\n\n  def down do\n    alter table(:users) do\n      add :facebook_id, :string\n      add :facebook_access_token, :string\n    end\n\n    flush()\n\n    set_identity_columns()\n  end\n\n  defp create_user_identities() do\n    user_identities =\n      \"users\"\n      |> where([u], not is_nil(u.facebook_id))\n      |> select([u], %{user_id: u.id, provider: \"facebook\", uid: u.facebook_id, inserted_at: u.inserted_at, updated_at: u.inserted_at})\n      # Or with access token:\n      # |> select([u], %{user_id: u.id, provider: \"facebook\", uid: u.facebook_id, access_token: u.facebook_access_token, inserted_at: u.inserted_at, updated_at: u.inserted_at})\n      |> Repo.all()\n\n    Repo.insert_all(\"user_identities\", user_identities)\n  end\n\n  defp set_identity_columns() do\n    \"user_identities\"\n    |> select([i], {i.user_id, %{facebook_id: i.uid}})\n    # Or with access token:\n    # |> select([i], {i.user_id, %{facebook_id: i.uid, facebook_access_token: i.access_token}})\n    |> where([i], i.provider == \"facebook\")\n    |> Repo.all()\n    |> Enum.each(fn {id, update} ->\n      \"users\"\n      |> where([u], u.id == ^id)\n      |> update(set: ^Map.to_list(update))\n      |> Repo.update_all([])\n    end)\n  end\nend\n```","ref":"legacy_migration.html"},{"type":"extras","title":"How to use PowAssent in an API","doc":"# How to use PowAssent in an API\n\nFollow the [Pow API guide](https://hexdocs.pm/pow/api.html) first to set up the API authorization plug.","ref":"api.html"},{"type":"extras","title":"Routes - How to use PowAssent in an API","doc":"Add the authorization routes to `lib/my_app_web/router.ex`:\n\n```elixir\ndefmodule MyAppWeb.Router do\n  use MyAppWeb, :router\n\n  # ...\n\n  scope \"/api/v1\", MyAppWeb.API.V1, as: :api_v1 do\n    pipe_through :api\n\n     # ...\n    get \"/auth/:provider/new\", AuthorizationController, :new\n    post \"/auth/:provider/callback\", AuthorizationController, :callback\n  end\n\n  # ...\nend\n```","ref":"api.html#routes"},{"type":"extras","title":"Add API controllers - How to use PowAssent in an API","doc":"Create `lib/my_app_web/controllers/api/v1/authorization_controller.ex`:\n\n```elixir\ndefmodule MyAppWeb.API.V1.AuthorizationController do\n  use MyAppWeb, :controller\n\n  alias Plug.Conn\n  alias PowAssent.Plug\n\n  @spec new(Conn.t(), map()) :: Conn.t()\n  def new(conn, %{\"provider\" => provider}) do\n    conn\n    |> Plug.authorize_url(provider, redirect_uri(conn))\n    |> case do\n      {:ok, url, conn} ->\n        json(conn, %{data: %{url: url, session_params: conn.private[:pow_assent_session_params]}})\n\n      {:error, _error, conn} ->\n        conn\n        |> put_status(500)\n        |> json(%{error: %{status: 500, message: \"An unexpected error occurred\"}})\n    end\n  end\n\n  defp redirect_uri(conn) do\n    \"https://client.example.com/auth/#{conn.params[\"provider\"]}/callback\"\n  end\n\n  @spec callback(Conn.t(), map()) :: Conn.t()\n  def callback(conn, %{\"provider\" => provider} = params) do\n    session_params = Map.fetch!(params, \"session_params\")\n    params         = Map.drop(params, [\"provider\", \"session_params\"])\n\n    conn\n    |> Conn.put_private(:pow_assent_session_params, session_params)\n    |> Plug.callback_upsert(provider, params, redirect_uri(conn))\n    |> case do\n      {:ok, conn} ->\n        json(conn, %{data: %{access_token: conn.private.api_access_token, renewal_token: conn.private.api_renewal_token}})\n\n      {:error, conn} ->\n        conn\n        |> put_status(500)\n        |> json(%{error: %{status: 500, message: \"An unexpected error occurred\"}})\n    end\n  end\nend\n```\n\n`session_params` should be stored in the client. `https://client.example.com/auth/:provider/callback` is the client side URI where the user will be redirected back to after authorization. The client should then send a POST request from the client to the callback URI in the API with the both the params received from the provider, and the `session_params` stored in the client.\n\nThat's it!\n\nYou can now set up your client to connect to your API and generate session tokens after successful provider callback. You can run the following curl commands to test it out:\n\n```bash\n$ curl -d http://localhost:4000/api/v1/auth/PROVIDER/new\n{\"data\":{\"url\":\"https://client.example.com/auth/PROVIDER/callback\",\"session_params\":{\"state\":\"STATE\"}}}\n\n$ curl -X POST -d \"code=CODE&session_params[state]=STATE\" http://localhost:4000/api/v1/auth/PROVIDER/callback\n{\"data\":{\"renew_token\":\"RENEW_TOKEN\",\"token\":\"AUTH_TOKEN\"}}\n```","ref":"api.html#add-api-controllers"},{"type":"extras","title":"Test modules - How to use PowAssent in an API","doc":"```elixir\n# test/my_app_web/controllers/api/v1/authorization_controller_test.exs\ndefmodule MyAppWeb.API.V1.AuthorizationControllerTest do\n  use MyAppWeb.ConnCase\n\n  @otp_app :my_app\n\n  defmodule TestProvider do\n    @moduledoc false\n    @behaviour Assent.Strategy\n\n    @impl true\n    def authorize_url(config) do\n      case config[:error] do\n        nil   -> {:ok, %{url: \"https://provider.example.com/oauth/authorize\", session_params: %{a: 1}}}\n        error -> {:error, error}\n      end\n    end\n\n    @impl true\n    def callback(_config, %{\"code\" => \"valid\"}), do: {:ok, %{user: %{\"sub\" => 1, \"email\" => \"test@example.com\"}, token: %{\"access_token\" => \"access_token\"}}}\n    def callback(_config, _params), do: {:error, \"Invalid params\"}\n  end\n\n  setup do\n    Application.put_env(@otp_app, :pow_assent,\n      providers: [\n        test_provider: [strategy: TestProvider],\n        invalid_test_provider: [strategy: TestProvider, error: :invalid]\n      ])\n\n    :ok\n  end\n\n  describe \"new/2\" do\n    test \"with valid config\", %{conn: conn} do\n      conn = get(conn, ~p\"/api/v1/auth/test_provider/new\")\n\n      assert json = json_response(conn, 200)\n      assert json[\"data\"][\"url\"] == \"https://provider.example.com/oauth/authorize\"\n      assert json[\"data\"][\"session_params\"] == %{\"a\" => 1}\n    end\n\n    test \"with error\", %{conn: conn} do\n      conn = get(conn, ~p\"/api/v1/auth/invalid_test_provider/new\")\n\n      assert json = json_response(conn, 500)\n      assert json[\"error\"][\"message\"] == \"An unexpected error occurred\"\n      assert json[\"error\"][\"status\"] == 500\n    end\n  end\n\n  describe \"callback/2\" do\n    @valid_params   %{\"code\" => \"valid\", \"session_params\" => %{\"a\" => 1}}\n    @invalid_params %{\"code\" => \"invalid\", \"session_params\" => %{\"a\" => 2}}\n\n    test \"with valid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/api/v1/auth/test_provider/callback?#{@valid_params}\")\n\n      assert json = json_response(conn, 200)\n      assert json[\"data\"][\"access_token\"]\n      assert json[\"data\"][\"renewal_token\"]\n    end\n\n    test \"with invalid params\", %{conn: conn} do\n      conn = post(conn, ~p\"/api/v1/auth/test_provider/callback?#{@invalid_params}\")\n\n      assert json = json_response(conn, 500)\n      assert json[\"error\"][\"message\"] == \"An unexpected error occurred\"\n      assert json[\"error\"][\"status\"] == 500\n    end\n  end\nend\n```","ref":"api.html#test-modules"},{"type":"extras","title":"Dynamic strategy configuration","doc":"# Dynamic strategy configuration\n\nIn some cases it'll be necessary to dynamically update the provider strategy based on context. PowAssent includes `PowAssent.Plug.merge_provider_config/3` to dynamically update the provider configuration.\n\nWith this function the configuration can be updated based on attributes within the `conn`. A common use cases would be to update request parameters based on query parameters, such as setting the `connection` for Auth0 strategy:\n\n```elixir\n# lib/my_app_web/pow_assent_auth0_plug.ex\ndefmodule MyAppWeb.PowAssentAuth0Plug do\n  def init(opts), do: opts\n\n  def call(conn, _opts) do\n    updated_config = [authorization_params: [connection: conn.params[\"connection\"]]]\n\n    PowAssent.Plug.merge_provider_config(conn, :auth0, updated_config)\n  end\nend\n\n# lib/my_app_web/router.ex\ndefmodule MyAppWeb.Router do\n  # ...\n\n  pipeline :configure_auth0 do\n    plug MyAppWeb.PowAssentAuth0Plug\n  end\n\n  scope \"/\" do\n    pipe_through [:browser, :configure_auth0]\n\n    pow_routes()\n    pow_assent_routes()\n  end\n\n  # ...\nend\n```","ref":"dynamic_strategy_configuration.html"},{"type":"extras","title":"Incremental authorization with Google - Dynamic strategy configuration","doc":"Google (and many other OAuth 2.0 providers that support granular `scope` configuration) strongly recommends to only request authorization with the minimum required scopes on first signup to keep the onboarding experience smooth. This will minimize the number of consent modals for the end-user by not asking for a bunch of permissions that your app won't even need up-front.\n\nThe below example will show how you enable [Incremental Authorization with the Google strategy](https://developers.google.com/identity/protocols/oauth2/web-server#incrementalAuth).\n\nIn this case, you may only want to request the `email` and `profile` scopes when user signs up, but enable opt-in Google Drive scope. Let's set up a custom plug to add the required scopes based on query param.\n\nFirst we remove the scope from the config:\n\n```elixir\n# config/config.exs\nconfig :my_app, :pow_assent,\n  providers: [\n    google: [\n      client_id: System.get_env(\"GOOGLE_CLIENT_ID\"),\n      client_secret: System.get_env(\"GOOGLE_CLIENT_SECRET\"),\n      authorization_params: [\n        access_type: \"offline\",\n        prompt: \"consent\",\n        include_granted_scopes: true\n      ],\n      strategy: Assent.Strategy.Google\n    ]\n  ]\n```\n\nThen we set up a plug to add optional scopes:\n\n```elixir\n# lib/my_app_web/pow_assent_google_incremental_auth_plug.ex\ndefmodule MyAppWeb.PowAssentGoogleIncrementalAuthPlug do\n  @moduledoc \"\"\"\n  This plug enables incremental auth scopes for the Google strategy.","ref":"dynamic_strategy_configuration.html#incremental-authorization-with-google"},{"type":"extras","title":"Example - Dynamic strategy configuration","doc":"plug MyAppWeb.PowAssentGoogleIncrementalAuthPlug\n  \"\"\"\n  def init(opts), do: opts\n\n  @required_scopes [\n    \"https://www.googleapis.com/auth/userinfo.email\",\n    \"https://www.googleapis.com/auth/userinfo.profile\"\n  ]\n\n  @optional_scopes %{\n    \"google_drive\" => [\"https://www.googleapis.com/auth/drive.file\"]\n  }\n\n  def call(conn, _opts) do\n    additional_scopes =\n      @optional_scopes\n      |> Map.keys()\n      |> Enum.filter(& &1 in Map.keys(conn.params))\n      |> Enum.map(& @optional_scopes[&1])\n\n    scope = Enum.join(@required_scopes ++ additional_scopes, \" \")\n\n    PowAssent.Plug.merge_provider_config(conn, :google, authorization_params: [scope: scope])\n  end\nend\n```\n\nAnd finally we add this plug to the pipeline:\n\n```elixir\n# lib/my_app_web/router.ex\ndefmodule MyAppWeb.Router do\n  # ...\n\n  pipeline :configure_google do\n    plug MyAppWeb.PowAssentGoogleIncrementalAuthPlug\n  end\n\n  scope \"/\" do\n    pipe_through [:browser, :configure_google]\n\n    pow_routes()\n    pow_assent_routes()\n  end\n\n  # ...\nend\n```\n\nNow you can use the authorization url with the `google_drive=true` query to enable `drive.file` permission:\n\n```elixir\n~p\"/auth/google/new?#{[google_drive: true]}\"\n```\n\nYou can add any number of additional optional scopes to the plug.","ref":"dynamic_strategy_configuration.html#example"},{"type":"extras","title":"Test modules - Dynamic strategy configuration","doc":"```elixir\n# test/my_app_web/pow_assent_google_incremental_auth_plug_test.exs\ndefmodule MyAppWeb.PowAssentGoogleIncrementalAuthPlugTest do\n  use MyAppWeb.ConnCase\n\n  alias MyAppWeb.PowAssentGoogleIncrementalAuthPlug\n\n  @pow_config [otp_app: :my_app]\n  @provider :google\n  @plug_opts []\n\n  test \"call/2 without additional scopes\", %{conn: conn} do\n    conn = run_plug(~p\"/auth/#{@provider}/new\")\n\n    assert fetch_provider_scope(conn) ==\n      \"https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile\"\n  end\n\n  test \"call/2 with google_drive=true query\", %{conn: conn} do\n    conn = run_plug(~p\"/auth/#{@provider}/new?#{[google_drive: true]}\")\n\n    opts = PowAssentGoogleIncrementalAuthPlug.init(@plug_opts)\n    conn = PowAssentGoogleIncrementalAuthPlug.call(conn, opts)\n\n    assert fetch_provider_scope(conn) ==\n      \"https://www.googleapis.com/auth/userinfo.email https://www.googleapis.com/auth/userinfo.profile https://www.googleapis.com/auth/drive.file\"\n  end\n\n  defp fetch_provider_scope(conn) do\n    config = Pow.Plug.fetch_config(conn)\n\n    config[:pow_assent][:providers][@provider][:authorization_params][:scope]\n  end\n\n  defp run_plug(uri) do\n    opts = PowAssentGoogleIncrementalAuthPlug.init(@plug_opts)\n\n    :get\n    |> build_conn(uri)\n    |> Pow.Plug.put_config(@pow_config)\n    |> Plug.Conn.fetch_query_params()\n    |> PowAssentGoogleIncrementalAuthPlug.call(opts)\n  end\nend\n```","ref":"dynamic_strategy_configuration.html#test-modules"}],"content_type":"text/markdown"}